//
//  Arguments.cpp
//  Commandline Argument Handling
//
//  Created by Clemens Wacha.
//  Version 1.2
//  Copyright (c) 2005 Clemens Wacha. All rights reserved.
//

#include "Arguments.h"


using namespace std;


Arguments::Arguments() {}

Arguments::Arguments(int argc, char* argv[]) {
	for(int i = 0; i < argc; i++) {
		arg_list.push_back(argv[i]);
	}
}

Arguments::Arguments(const std::vector<std::string>& list) {
	arg_list = list;
}

Arguments::~Arguments() {}

bool Arguments::getFlag(const std::string& option, const std::string& long_option) {
	std::vector<std::string>::iterator iter;
	
	for(iter = arg_list.begin(); iter != arg_list.end(); iter++) {
		if(*iter == option || *iter == long_option) {
			arg_list.erase(iter);
			return 1;
		}
	}
	
	return 0;
}

std::string Arguments::front() {
	std::string ret;
	
	if(arg_list.size() > 0) {
		ret = arg_list.front();
		arg_list.erase( arg_list.begin() );
		return ret;
	} else {
		return std::string();
	}
}

std::string Arguments::back() {
	std::string ret;
	
	if(arg_list.size() > 0) {
		ret = arg_list.back();
		arg_list.pop_back();
		return ret;
	} else {
		return std::string();
	}
}

unsigned int Arguments::size() {
	return arg_list.size();
}

std::string Arguments::list() {
	std::string tmp;
	
	for(unsigned int i = 0; i < arg_list.size(); i++) {
		tmp += arg_list[i];
		tmp += ", ";
	}
	
	if( arg_list.size() > 0) {
		tmp = tmp.substr(0, tmp.size()-2);
	}
	
	return tmp;
}

/*
std::string Arguments::argument(const std::string& option, const std::string& default_value, const std::string& long_option) {
	std::vector<std::string>::iterator iter;
	std::string ret;
	
	if(arg_list.size() < 2) return default_value;
	
	for(iter = arg_list.begin(); iter +1 != arg_list.end(); iter++ ) {
		if(*iter == option || *iter == long_option) {
			ret = *(iter + 1);
			arg_list.erase(iter+1);
			arg_list.erase(iter);
			return ret;
		}
	}
	
	//not found, return default value
	return default_value;
}

int Arguments::getInt(const std::string& option, const std::string& default_value, const std::string& long_option) {
	return atoi( argument(option, default_value, long_option).c_str() );
}


long Arguments::getLong(const std::string& option, const std::string& default_value, const std::string& long_option) {
	return atol( argument(option, default_value, long_option).c_str() );
}

float Arguments::getFloat(const std::string& option, const std::string& default_value, const std::string& long_option) {
	return atof( argument(option, default_value, long_option).c_str() );
}


double Arguments::getDouble(const std::string& option, const std::string& default_value, const std::string& long_option) {
	return atof( argument(option, default_value, long_option).c_str() );
}

std::string Arguments::getString(const std::string& option, const std::string& default_value, const std::string& long_option) {
	return argument(option, default_value, long_option);
}

char* Arguments::getCString(const std::string& option, const std::string& default_value, const std::string& long_option) {
	string tmp = argument(option, default_value, long_option);
	return strdup( tmp.c_str());
}
*/



